﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace MultipleExceptions
{
    class Program
    {
        static void MethodA() { throw new Exception("TaskA Exception"); }
        static void MethodB() { throw new Exception("TaskB Exception"); }
        static void MethodC() { throw new Exception("TaskC Exception"); }

        static void Main(string[] args)
        {
            try {

                var TaskA = Task.Factory.StartNew(MethodA);
                var TaskB = Task.Factory.StartNew(MethodB);
                var TaskC = Task.Factory.StartNew(MethodC);

               // Unhandled exception observed

                Task.WaitAll(new Task[] {TaskA, TaskB, TaskC}); 
            }

            catch (AggregateException ae) {

                foreach (var ex in ae.InnerExceptions) {

                    // .. handle exceptions

                    Console.WriteLine(ex.Message);
                }

            }

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}
