﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Cancellation
{
    class Program
    {
        static void DoSomething() { Thread.SpinWait(int.MaxValue); }

        static void Main(string[] args)
        {
            CancellationTokenSource cancellationSource =
                new CancellationTokenSource();
            CancellationToken token = cancellationSource.Token;
            try
            {
            Task TaskA=Task.Factory.StartNew(() =>
            {
                while (true)
                {
                    DoSomething();
                    if (token.IsCancellationRequested)
                    {

                        token.ThrowIfCancellationRequested();
                    }
                }

            }, token);
            Thread.Sleep(1000);
            cancellationSource.Cancel();

            TaskA.Wait();
            }
            catch (AggregateException ex)
            {
                Console.WriteLine(ex.InnerException.Message);
            }

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}
