﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ContinuationResult
{
    class Program
    {
        static void Main(string[] args)
        {
            var calculate = new Task<int>(() =>
            {
                Console.WriteLine("Calculate result."); return 42;
            });

            var answer=calculate.ContinueWith((predecessor) =>{ 
                    Console.WriteLine("The answer is {0}.", predecessor.Result); });

           calculate.Start();
           Task.WaitAll(calculate, answer);            
            
           Console.WriteLine("Press enter to exit");
           Console.ReadLine();
        }
    }
}
