﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Exception
{
    class Program
    {
        static void Main(string[] args)
        {
            int [] intArray = { 5, 1, 2, 7, 4, 0, 6, 2, 9, 0 };
            var results = intArray.AsParallel().Select(item =>  (int)1000 / (int) item);

            try
            {
                results.ForAll((item) => Console.WriteLine(item));
            }
            catch(AggregateException ex)
            {
                foreach (var inner in ex.InnerExceptions)
                {
                    Console.WriteLine(inner.Message);
                }
            }

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}
