﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Concurrent;
using System.Threading.Tasks;
using System.Threading;

namespace GetConsumingEnumerable
{
    class Program
    {
        private static BlockingCollection<int> collection=new BlockingCollection<int>();

        static void Main(string[] args)
        {
            try
            {

                int count = 0;
                Parallel.Invoke(new Action[] {
                ()=> { while(true) {collection.Add(++count); Thread.Sleep(2000);}},
                ()=> { Console.ReadLine(); collection.CompleteAdding(); },
                ()=> {foreach(int value in collection.GetConsumingEnumerable()) Console.WriteLine(value);}});

            }
            catch(AggregateException ex)
            {   
                if (ex.InnerException is System.InvalidOperationException)
                {
                    Console.WriteLine("Adding  complete!");
                }
                else
                {
                    Console.WriteLine("Unexpected exception");
                }
            }
            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}
