﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Collections.Concurrent;

namespace BasicExample
{
    class Program
    {
        static int partition= 0;


        static void Main(string[] args)
        {
            var numbers = Enumerable.Range(0,50).ToArray();

            Parallel.ForEach(Partitioner.Create(0, numbers.Length), 
(range, notused, partition ) =>
            {
                string buffer = string.Format("Partition {0,3}: ", partition);
                for (int index = range.Item1; index < range.Item2; ++index)
                {
                    Thread.SpinWait(4000);
                    buffer+=string.Format(" {0,3}", numbers[index]);
                }
                Console.WriteLine(buffer);
            });

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}