﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace VisualizerTutorial
{
    class Program
    {
        static void DoSomething()
        {
            Thread.SpinWait(int.MaxValue / 10);
        }

        static void ParallelLoop()
        {
            var numbers = Enumerable.Range(0, 1000);
            Parallel.ForEach(numbers, (number) =>
            {
                DoSomething();
            } );
        }

        static void Main(string[] args)
        {
            Thread t1 = new Thread(new ThreadStart(ParallelLoop));
            t1.IsBackground = true;
            t1.Start();

            object sync = new object();
            Thread t2 = new Thread(new ThreadStart(() =>
            {
                lock (sync)
                {
                    Thread.Sleep(2000);
                }
            }));
            t2.IsBackground=true;
            t2.Start();

            Thread t3=new Thread(new ThreadStart(() =>
            {
                lock (sync)
                {
                    Thread.Sleep(2000);
                }
            }));
            t3.IsBackground=true;
            t3.Start();

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}
