﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace HandleException
{
    class Program
    {
        static void MethodA() { throw new Exception("TaskA Exception"); }
        static void MethodB() { throw new Exception("TaskB Exception"); }
        static void MethodC() { throw new Exception("TaskC Exception"); }
        
        static void Main(string[] args)
        {
            try
            {
                Parallel.Invoke(new Action[] { MethodA, MethodB, MethodC });
            }
            catch (AggregateException ae)
            {
                ae.Handle(ex =>
                {
                    Console.WriteLine(ex.Message);
                    return true;
                });
            }
            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
       }
    }
}
