﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ParallelForException
{
    
    class Program
    {
        static void DoSomething()
        {
            Thread.SpinWait(int.MaxValue);
        }

        static void Main(string[] args)
        {
            try
            {
                Parallel.For(0, 6, (index) =>
                {
                    Console.WriteLine("Task {0} started.", index);
                    if (index == 4)
                    {
                        Console.WriteLine("Exception raised in Task {0}.", index);
                        throw new Exception();
                    }
                    DoSomething();
                    Console.WriteLine("Task {0} ended.", index);
                });
            }
            catch (AggregateException ax)
            {
                Console.WriteLine("\nError List: \n");
                foreach(var error in ax.InnerExceptions)
                {
                    Console.WriteLine(error.Message);
                }
            }

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}
