﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
namespace Matrix
{
    class Program
    {
        static void Main(string[] args)
        {
            const int len = 4;
            var first = new int [len] { 1, 2, 3, 4};
            var second = new int[len] { 5, 6, 7, 8};
            var third = Enumerable.Range(0, first.Length).AsParallel()
                .Aggregate(new int[len], (result, index) =>
                {
                    result.SetValue(first[index] * second[index], index);
                    return result;
                },
                (total, subtotal) => total,
                (result) => result);

            Console.WriteLine("First");
            foreach (var element in first)
            {
                Console.Write(element+" ");
            }

            Console.WriteLine("\nSecond");

            foreach (var element in second)
            {
                Console.Write(element+" ");
            }

            Console.WriteLine("\nThird (result)");

            foreach (var element in third)
            {
                Console.Write(element + " ");
            }

            Console.WriteLine("\nPress enter to exit");
            Console.ReadLine();
        }

    }
}
